import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import ModelloLiberatoriaService from '@/entities/modello-liberatoria/modello-liberatoria.service';
import UtenteAppService from '@/entities/utente-app/utente-app.service';
import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import LiberatoriaUpdate from './liberatoria-update.vue';
import LiberatoriaService from './liberatoria.service';

type LiberatoriaUpdateComponentType = InstanceType<typeof LiberatoriaUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const liberatoriaSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<LiberatoriaUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('Liberatoria Management Update Component', () => {
    let comp: LiberatoriaUpdateComponentType;
    let liberatoriaServiceStub: SinonStubbedInstance<LiberatoriaService>;

    beforeEach(() => {
      route = {};
      liberatoriaServiceStub = sinon.createStubInstance<LiberatoriaService>(LiberatoriaService);
      liberatoriaServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          liberatoriaService: () => liberatoriaServiceStub,
          utenteAppService: () =>
            sinon.createStubInstance<UtenteAppService>(UtenteAppService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
          modelloLiberatoriaService: () =>
            sinon.createStubInstance<ModelloLiberatoriaService>(ModelloLiberatoriaService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(LiberatoriaUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(LiberatoriaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.liberatoria = liberatoriaSample;
        liberatoriaServiceStub.update.resolves(liberatoriaSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(liberatoriaServiceStub.update.calledWith(liberatoriaSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        liberatoriaServiceStub.create.resolves(entity);
        const wrapper = shallowMount(LiberatoriaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.liberatoria = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(liberatoriaServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        liberatoriaServiceStub.find.resolves(liberatoriaSample);
        liberatoriaServiceStub.retrieve.resolves([liberatoriaSample]);

        // WHEN
        route = {
          params: {
            liberatoriaId: `${liberatoriaSample.id}`,
          },
        };
        const wrapper = shallowMount(LiberatoriaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.liberatoria).toMatchObject(liberatoriaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        liberatoriaServiceStub.find.resolves(liberatoriaSample);
        const wrapper = shallowMount(LiberatoriaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
